
        .XCREF
        .NOLIST
        INCLUDE    \masm32\include\masm32rt.inc
        .LIST

EnumFonts  PROTO :DWORD,:DWORD,:DWORD,:DWORD
EnumFamily PROTO :DWORD,:DWORD,:DWORD,:DWORD

_OUTLINETEXTMETRIC STRUCT
  otmSize                dd ?
  otmTextMetrics         TEXTMETRIC <>
  otmFillerBytes         db 4 dup(?)
  otmPanoseNumber        PANOSE <>
  otmFillerByte          db ?
  otmfsSelection         dd ?
  otmfsType              dd ?
  otmsCharSlopeRise      dd ?
  otmsCharSlopeRun       dd ?
  otmItalicAngle         dd ?
  otmEMSquare            dd ?
  otmAscent              dd ?
  otmDescent             dd ?
  otmLineGap             dd ?
  otmsCapEmHeight        dd ?
  otmsXHeight            dd ?
  otmrcFontBox           RECT <>
  otmMacAscent           dd ?
  otmMacDescent          dd ?
  otmMacLineGap          dd ?
  otmusMinimumPPEM       dd ?
  otmptSubscriptSize     POINT <>
  otmptSubscriptOffset   POINT <>
  otmptSuperscriptSize   POINT <>
  otmptSuperscriptOffset POINT <>
  otmsStrikeoutSize      dd ?
  otmsStrikeoutPosition  dd ?
  otmsUnderscoreSize     dd ?
  otmsUnderscorePosition dd ?
  otmpFamilyName         dd ?
  otmpFaceName           dd ?
  otmpStyleName          dd ?
  otmpFullName           dd ?
_OUTLINETEXTMETRIC ENDS

        .DATA?

hWndDesktop dd ?
hDcDesktop  dd ?
hDcCompat   dd ?
hFont       dd ?
hOldFont    dd ?
lpfnGOTM    dd ?

lf LOGFONT <>
lf2 LOGFONT <>
; lfHeight           dd ?
; lfWidth            dd ?
; lfEscapement       dd ?
; lfOrientation      dd ?
; lfWeight           dd ?
; lfItalic           db ?
; lfUnderline        db ?
; lfStrikeOut        db ?
; lfCharSet          db ?
; lfOutPrecision     db ?
; lfClipPrecision    db ?
; lfQuality          db ?
; lfPitchAndFamily   db ?
; lfFaceName         db LF_FACESIZE dup(?) ;LF_FACESIZE = 32

tm TEXTMETRIC <>
; tmHeight           dd ?
; tmAscent           dd ?
; tmDescent          dd ?
; tmInternalLeading  dd ?
; tmExternalLeading  dd ?
; tmAveCharWidth     dd ?
; tmMaxCharWidth     dd ?
; tmWeight           dd ?
; tmOverhang         dd ?
; tmDigitizedAspectX dd ?
; tmDigitizedAspectY dd ?
; tmFirstChar        db ?
; tmLastChar         db ?
; tmDefaultChar      db ?
; tmBreakChar        db ?
; tmItalic           db ?
; tmUnderlined       db ?
; tmStruckOut        db ?
; tmPitchAndFamily   db ?
; tmCharSet          db ?

ncm NONCLIENTMETRICS <>
; cbSize           dd ?
; iBorderWidth     dd ?
; iScrollWidth     dd ?
; iScrollHeight    dd ?
; iCaptionWidth    dd ?
; iCaptionHeight   dd ?
; lfCaptionFont    LOGFONT <>
; iSMCaptionWidth  dd ?
; iSMCaptionHeight dd ?
; lfSMCaptionFont  LOGFONT <>
; iMenuWidth       dd ?
; iMenuHeight      dd ?
; lfMenuFont       LOGFONT <>
; lfStatusFont     LOGFONT <>
; lfMessageFont    LOGFONT <>
;   lfHeight         dd ?
;   lfWidth          dd ?
;   lfEscapement     dd ?
;   lfOrientation    dd ?
;   lfWeight         dd ?
;   lfItalic         db ?
;   lfUnderline      db ?
;   lfStrikeOut      db ?
;   lfCharSet        db ?
;   lfOutPrecision   db ?
;   lfClipPrecision  db ?
;   lfQuality        db ?
;   lfPitchAndFamily db ?
;   lfFaceName       db LF_FACESIZE dup(?) ;LF_FACESIZE = 32

;-------------------------------------

        .CODE

_main   PROC

        INVOKE  GetDesktopWindow
        mov     hWndDesktop,eax
        INVOKE  GetDC,eax
        mov     hDcDesktop,eax
        INVOKE  CreateCompatibleDC,eax
        mov     hDcCompat,eax

        mov     ebx,offset lf
        xor     edx,edx
        mov     [ebx].LOGFONT.lfCharSet,dl
        mov     [ebx].LOGFONT.lfPitchAndFamily,dl
        mov     [ebx].LOGFONT.lfFaceName,dl
        INVOKE  EnumFontFamiliesEx,eax,ebx,EnumFonts,edx,edx
        print   chr$(13,10,13,10)

        INVOKE  DeleteDC,hDcCompat
        INVOKE  ReleaseDC,hWndDesktop,hDcDesktop

        inkey
        exit

_main   ENDP

;-------------------------------------

EnumFonts PROC uses ebx esi edi lpelfe:DWORD,lpntme:DWORD,FontType:DWORD,lParam:DWORD

        mov     ebx,lpelfe
        lea     esi,[ebx].LOGFONT.lfFaceName
        cmp byte ptr FontType,1
        jnz     EnFnt0

        print   chr$(13,10)               ;display the name for fixed-pitch fonts
        print   esi
        print   chr$(32)

EnFnt0: mov     ebx,offset lf2
        lea     edi,[ebx].LOGFONT.lfFaceName
        mov     ecx,8
        rep     movsd

        xor     edx,edx
        mov     [ebx].LOGFONT.lfCharSet,dl
        mov     [ebx].LOGFONT.lfPitchAndFamily,dl
        INVOKE  EnumFontFamiliesEx,hDcCompat,ebx,EnumFamily,edx,edx

        mov     eax,TRUE
        ret

EnumFonts ENDP

;-------------------------------------

EnumFamily PROC uses ebx esi lpelfe:DWORD,lpntme:DWORD,FontType:DWORD,lParam:DWORD

        cmp     byte ptr FontType,1
        jz      EnFam0

        INVOKE  CreateFontIndirect,lpelfe
        mov     hFont,eax
        INVOKE  SelectObject,hDcCompat,eax
        mov     hOldFont,eax

        mov     esi,esp
        INVOKE  GetOutlineTextMetrics,hDcCompat,0,0
        add     eax,3
        and     eax,-4
        sub     esp,eax
        mov     ebx,esp
        INVOKE  GetOutlineTextMetrics,hDcCompat,eax,ebx
        print   chr$(13,10)
        mov     eax,lpelfe
        lea     eax,[eax].LOGFONT.lfFaceName
        print   eax
        print chr$(', ')
        mov     eax,[ebx]._OUTLINETEXTMETRIC.otmpStyleName
        add     eax,ebx
        print   eax

        mov     esp,esi
        INVOKE  SelectObject,hDcCompat,hOldFont
        INVOKE  DeleteObject,eax
        jmp     EnFam1

EnFam0: mov     ebx,lpelfe
        print   str$([ebx].LOGFONT.lfWidth),'x'
        print   str$([ebx].LOGFONT.lfHeight),32

EnFam1: mov     eax,TRUE
        ret

EnumFamily ENDP

;-------------------------------------

        END     _main

